<?php

/**
 * diligencia actions.
 *
 * @package    cobro_coactivo
 * @subpackage diligencia
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class diligenciaActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CBR_DILIGENCIA',
        'CBR_SECUESTRO',
        'CBR_PROCESO_COACTIVO',
        'CBR_REMISION_TITULO',
        'CBR_TITULO_MINERO_V',
        'CBR_ACTUACION_PROC'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CBR_SECUESTRO' =>
        array(
            'id_secuestro' => 'CBR_DILIGENCIA'
        ),
       /* 'CBR_PROCESO_COACTIVO' =>
        array(
            'id_proceso_coactivo' => 'CBR_SECUESTRO'
        ),*/
        'CBR_REMISION_TITULO' =>
        array(
            'id_remision_titulo' => 'CBR_SECUESTRO'
        ),
        'CBR_TITULO_MINERO_V,LEFT' =>
        array(
            'cod_titulo' => 'CBR_REMISION_TITULO'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CBR_DILIGENCIA' =>
        array(
            'id_diligencia' => 'id_diligencia',
            'id_secuestro' => 'id_secuestro',
            'no_acta' => 'no_acta',
            'fecha' => 'fecha',
            'detalle_plantilla' => 'detalle_plantilla',
            'observaciones' => 'observaciones',
            'adjunto' => 'adjunto'
        ),
        'CBR_SECUESTRO' =>
        array(
            
            'fecha' => 'fecha_secuestro'
        ),
        /*'CBR_PROCESO_COACTIVO' =>
        array(
            'id_remision_titulo' => 'id_remision_titulo',
            'no_proceso' => 'no_proceso',
            'fecha' => 'fecha_coactivo',
            'id_anhos' => 'id_anhos'
        ),*/
        'CBR_REMISION_TITULO' =>
        array(
            'numero_remision' => 'numero_remision',
            'anho_remision' => 'anho_remision',
            'fecha_remision' => 'fecha_remision',
            'estado' => 'estado',
            'cod_titulo' => 'cod_titulo'
        ),
        'CBR_TITULO_MINERO_V' =>
        array(
            'mineral' => 'mineral',
            'id_debito' => 'id_debito',
            'id_mineral' => 'id_mineral'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CBR_DILIGENCIA' =>
        array(
            'id_diligencia,a' => array('!=' => array(-1)),
            'id_diligencia,b' => array('=' => array('id_diligencia')),
            'id_secuestro' => array('=' => array('id_secuestro')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        ),
        /*'CBR_PROCESO_COACTIVO' =>
        array(
            'no_proceso' => array('=' => array('no_proceso')),
            'id_anhos' => array('=' => array('id_anhos'))
        ),*/
        'CBR_REMISION_TITULO' =>
        array(
            'cod_titulo' => array('=' => array('cod_titulo'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_diligencia'; //identificador de la tabla
    protected $id_names = array('id_diligencia'); //llave primaria
    protected $field_names = array('id_secuestro', 'no_acta', 'fecha', 'detalle_plantilla', 'observaciones', 'adjunto',
    'id_plantilla','id_tipo_documento','fecha_log','usuario_log'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CBR_DILIGENCIA'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_diligencia'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();
            try {
                $id_diligencia = $list_data_post[0]['id_diligencia'];

                if ($request['id_plantilla'] != "") {
                    $id_plantilla = $request['id_plantilla'];
                    $sql = <<<EOD
UPDATE CBR_DILIGENCIA SET DETALLE_PLANTILLA=(select detalle from cbr_plantilla where id_plantilla = $id_plantilla) where id_diligencia=$id_diligencia
EOD;


                    $this->conn->execute($sql);
                }


                $this->conn->commit();
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            $sql = <<<EOD
select to_char(sysdate,'YYYY') as ID_ANHOS, to_char(sysdate,'yyyy-mm-dd') as fecha_actual FROM DUAL
EOD;

            $records = CN_TABLE::executeSQL($sql);

            $id_tipo_documento = 2; //ACTA
            $id_anhos = $records[0]['id_anhos'];
            $fecha_actual = $records[0]['fecha_actual'];
            $usuario = $request['id_username'];
            $request['id_tipo_documento']=$id_tipo_documento;
            $request['fecha_log']=$fecha_actual;
            $request['usuario_log']=$usuario;





            $sql = <<<EOD
select consecutivo from cbr_consecutivo_doc where id_tipo_documento= $id_tipo_documento and id_anhos = $id_anhos
EOD;
            $records = CN_TABLE::executeSQL($sql);

            $consecutivo = $records[0]['consecutivo'];

            $request['no_acta'] = $consecutivo;
 	    $request['no_acta'] = str_pad($request['no_acta'], 4, "0", STR_PAD_LEFT);

            $sql = <<<EOD
update cbr_consecutivo_doc set consecutivo =($consecutivo+1) where id_tipo_documento= $id_tipo_documento and id_anhos = $id_anhos
EOD;

            CN_TABLE::executeSQL($sql);
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;


        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

}
